<?php
/**
 * MySQL database adapter
 */
class db_mysql extends db_adapter {
    var $db = null;

    /**
     * MySQL constructor.
     * Can be called using a host, user, pass and database or alternatively it 
     * can be called using just an existing mysql ressource (mysql_connect
     * object)
     * When using a tunnel:
     *   Use 127.0.0.1 instead of localhost, because localhost will try to use 
     *   sockets instead of an IP connection.
     */
    public function db_mysql($host, $user = null, $pass = null, $dbase = null) {
        assert('function_exists("mysql_connect")');

        // host or existing conneciton given
        if (is_string($host)) {
            assert('is_string($user)');
            assert('is_string($pass)');
            assert('is_string($dbase)');
            $db = @mysql_connect($host, $user, $pass);
            if ($db == false) return;

            if (!mysql_select_db($dbase, $db)) return;
        } else {
            $db = $host;
        }

        $this->db = $db;
    }

    /**
     * Issue a database query.
     * If an error occurs, program execution will be terminated.
     */
    public function query($query) {   
        $this->log_query($query, false); // pre
        $result = mysql_query($query, $this->db);
        $this->log_query($query, true); // post
        if ($result === false) {
            assert('false /* Invalid query: ' . mysql_error().' Query: '.$query.' */');
            die(); // in case that assert does not break
        }
        return $result;
    }

    public function query_row($query) {   
        $resultset = $this->query($query);
        $result = mysql_fetch_assoc($resultset);
        return $result;
    }

    public function query_all($query) {
        $result = $this->query($query);
        $all = array();
        while ($row = mysql_fetch_assoc($result)) array_push($all, $row);
        return $all;
    }

    function quote_table_name($table_name) {
        return '`'.mysql_real_escape_string($table_name).'`';
    }

    public function escape_string($str)
    {
        return mysql_real_escape_string($str);
    }

    public function last_insert_id($table = null) {
        return mysql_insert_id($this->db);
    }


    public function update($table, $record, $id) {
        $query = "UPDATE ".$this->quote_table_name($table)." SET ";
        $add_colon = false;
        foreach (array_keys($record) as $attr) {
            if ($add_colon) $query .= ', ';
            $query .= '`' . $attr . '`=';
            if ($record[$attr] == null) {
                $query .= "NULL ";
            } else {
                $query .= "'" . mysql_escape_string($record[$attr]) . "' ";
            }
            $add_colon = true;
        }
        $query .= "WHERE `id`=". $id . ";";

        // a least one change => query
        if (!$add_colon) return;

        // finally query
        $this->query($query);
    }

    /**
     * Optimize this table. Call e.g. from Admin interface or once on long 
     * program run.
     */
    public static function optimize($table) {
        $query = 'OPTIMIZE TABLE '.$this->quote_table_name($table).';';

        // TODO evaluate result
        $this->db->query($query);
    }

    // TODO: set next autoindex
    // mysql: ALTER TABLE `user` AUTO_INCREMENT=100

    /**
     * Fetch fiels of a table
     */
    public function fetch_columns($table) {
        $columns = array();
        $result = $this->query('SHOW FIELDS FROM '.$this->quote_table_name($table).';');
        while ($row = mysql_fetch_assoc($result)) {
            $columns[$row['Field']] = $this->convert_type($row['Type']);
        }
        return $columns;
    }

    /**
     * Convert database type to php type
     */
    private function convert_type($t) {
        if ($t == 'bit(1)') return 'bool';
        if ($t == 'tinyint(1)') return 'integer';
        if ($t == 'tinyint(3) unsigned') return 'integer';
        if ($t == 'tinyint(4)') return 'integer';
        if ($t == 'int(11)') return 'integer';
        if ($t == 'float') return 'float';
        if ($t == 'date') return 'time';
        if ($t == 'datetime') return 'time';
        if ($t == 'timestamp') return 'time';
        if ($t == 'text') return 'string';
        if (substr($t, 0, 7) == 'varchar') return 'string';
        if (substr($t, 0, 4) == 'char') return 'string';
        die('Which type is: '. $t);
    }

    /**
     */
    public function init() {
    }

    /**
     * Select one single number from the database (e.g. a count)
     */
    public function select_single($query) {
        $result = $this->query($query);
        $row = mysql_fetch_row($result);
        if ($row === false) die('Invalid query: ' . mysql_error().' Query: '.$query);
        assert('sizeof($row) == 1 /* ' . $query . ' */');
        return $row[0];
    }
}

